/*
  X86 EMULATOR by Kamil Korolkiewicz 2007
  Plik:func.h
  Opis:Funkcje odpowiadajace instrukcjom procesora i ich indeksy.
*/

//indeksy funkcji

enum
{
 MOV=1,
 STOS=2,
 MOVS=3,
 CMPS=4,
 XCHG=5,
 NOP=6,
 PUSH=7,
 POP=8,
 ADD=9,
 OR=10,
 ADC=11,
 SBB=12,
 AND=13,
 SUB=14,
 XOR=15,
 CMP=16,
 ADDX=17,
 ORX=18,
 ADCX=19,
 SBBX=20,
 ANDX=21,
 SUBX=22,
 XORX=23,
 CMPX=24,
 INC=25,
 DEC=26,
 CALLN=27,
 CALLF=28,
 JMPN=29,
 JMPF=30,
 DAA=31,
 DAS=32,
 AAA=33,
 AAS=34,
 PUSHA=35,
 POPA=36,
 LEA=37,
 CBW=38,
 CWD=39,
 TEST=40,
 NOT=41,
 NEG=42,
 MUL=43,
 IMUL=44,
 DIV=45,
 IDIV=46,
 HLT=47,
 ROR=48,
 ROL=49,
 RCL=50,
 RCR=51,
 SHL=52,
 SHR=53,
 SAR=54,
 RETN=55,
 RETF=56,
 INP=57,
 OUTP=58,
 SCAS=59,
 XLAT=60,
 AAM=61,
 AAD=62,
 CALL=63,
 JMP=64,
 LODS=65,
 INT3=66,
 INTN=67,
 INTO=68,
 IRET=69,
 ENTER=70,
 LEAVE=71,
 LES=72,
 LDS=73,
 INS=74,
 OUTS=75,
 LOOPNE=76,
 LOOPE=77,
 LOOP=78,
 JCXZ=79,
 CLC=80,
 STC=81,
 CLI=82,
 STI=83,
 CLD=84,
 STD=85,
 CMC=86,
 WAIT=87,
 PUSHF=88,
 POPF=89,
 SAHF=90,
 LAHF=91,
 BOUND=92,
 ARPL=93,
 JO=94,
 JNO=95,
 JC=96,
 JNC=97,
 JZ=98,
 JNZ=99,
 JCZ=100,
 JNCZ=101,
 JS=102,
 JNS=103,
 JP=104,
 JNP=105,
 JL=106,
 JNL=107,
 JLE=108,
 JNLE=109,
 SHLD=110,
 SHRD=111,
 SLDT=112,
 SGDT=113,
 LLDT=114,
 LGDT=115,
 LTR=116,
 STR=117,
 LIDT=118,
 SIDT=119,
 SMSW=120,
 LMSW=121,
 VERR=122,
 VERW=123,
 INVLPG=124,
 FADD=125,
 FMUL=126,
 FCOM=127,
 FCOMP=128,
 FSUB=129,
 FSUBR=130,
 FDIV=131,
 FDIVR=132,
 FLD=133,
 FST=134,
 FSTP=135,
 FLDENV=136,
 FLDCW=137,
 FSTENV=138,
 FSTCW=139,
 FXCH=140,
 FABS=141,
 FTST=142,
 FXAM=143,
 FLD1=144,
 FLDL2T=145,
 FLDL2E=146,
 FLDPI=147,
 FLDLG2=148,
 FLDLN2=149,
 FLDZ=150,
 FYL2X=151,
 FPTAN=152,
 FPATAN=153,
 FXTRACT=154,
 FPREM1=155,
 FDECSTP=156,
 FINCSTP=157,
 FPREM=158,
 FYL2XP1=159,
 FSQRT=160,
 FSINCOS=161,
 FRNDINT=162,
 FSCALE=163,
 FSIN=164,
 FCOS=165,
 FCHS=166,
 FIADD=167,
 FIMUL=168,
 FICOM=169,
 FICOMP=170,
 FISUB=171,
 FISUBR=172,
 FIDIV=173,
 FIDIVR=174,
 FCMOVB=175,
 FCMOVE=176,
 FCMOVBE=177,
 FCMOVU=178,
 FUCOMPP=179,
 FCMOVNB=180,
 FCMOVNE=181,
 FCMOVNBE=182,
 FCMOVNU=183,
 FUCOMI=184,
 FCOMI=185,
 FILD=186,
 FIST=187,
 FISTP=188,
 FCLEX=189,
 FINIT=190,
 FRSTOR=191,
 FSAVE=192,
 FSTSW=193,
 FFREE=194,
 FUCOM=195,
 FUCOMP=196,
 FADDP=197,
 FMULP=198,
 FCOMPP=199,
 FSUBRP=200,
 FSUBP=201,
 FDIVRP=202,
 FDIVP=203,
 FBLD=204,
 FBSTP=205,
 FUCOMIP=206,
 FCOMIP=207, 
 MOVZX8=208,
 MOVZX16=209,
 MOVSX8=210,
 MOVSX16=211,
 SETO=212,
 SETNO=213,
 SETC=214,
 SETNC=215,
 SETZ=216,
 SETNZ=217,
 SETCZ=218,
 SETNCZ=219,
 SETS=220,
 SETNS=221,
 SETP=222,
 SETNP=223,
 SETL=224,
 SETNL=225,
 SETLE=226,
 SETNLE=227,
 CMOVO=228,
 CMOVNO=229,
 CMOVC=230,
 CMOVNC=231,
 CMOVZ=232,
 CMOVNZ=233,
 CMOVCZ=234,
 CMOVNCZ=235,
 CMOVS=236,
 CMOVNS=237,
 CMOVP=238,
 CMOVNP=239,
 CMOVL=240,
 CMOVNL=241,
 CMOVLE=242,
 CMOVNLE=243,
 LSS=244,
 LFS=245,
 LGS=246,
 CPUID=247,
 XADD=248,
 MOVC=249,
 MOVD=250,
 MOVSG=251,
 BT=252,
 BTS=253,
 BTR=254,
 BTC=255,
 BSF=256,
 BSR=257,
 LAR=258,
 LSL=259,
 CLTS=260,
 INVD=261,
 WBINVD=262,
 WRMSR=263,
 RDTSC=264,
 RDMSR=265,
 RDPMC=266,
 RSM=267,
 CMPXCHG=268,
 BSWAP=269,
 FCNT
};
